VERSION 5.00
Begin VB.Form DmineurForm 
   BackColor       =   &H8000000B&
   Caption         =   "Dmineur"
   ClientHeight    =   2865
   ClientLeft      =   1875
   ClientTop       =   2460
   ClientWidth     =   4320
   LinkTopic       =   "Form1"
   ScaleHeight     =   2865
   ScaleWidth      =   4320
   StartUpPosition =   2  'CenterScreen
   Begin VB.Label statusBar 
      Caption         =   "La barre de status .........................................."
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   2640
      Width           =   4335
   End
   Begin VB.Menu JeuMenu 
      Caption         =   "&Jeu"
      Begin VB.Menu NouvelleMenuItem 
         Caption         =   "&Nouvelle partie"
         Shortcut        =   ^N
      End
      Begin VB.Menu FinirMenuItem 
         Caption         =   "&Finir la partie"
         Shortcut        =   ^F
      End
      Begin VB.Menu TailleMenuItem 
         Caption         =   "&Taille"
         Shortcut        =   ^T
      End
      Begin VB.Menu QuitterMenuItem 
         Caption         =   "&Quitter"
         Shortcut        =   ^Q
      End
   End
   Begin VB.Menu meneNiveau 
      Caption         =   "&Niveau"
      Begin VB.Menu EasyMenuItem 
         Caption         =   "&Facil"
         Shortcut        =   ^{F1}
      End
      Begin VB.Menu NormalMenuItem 
         Caption         =   "&Normal"
         Checked         =   -1  'True
         Shortcut        =   ^{F2}
      End
      Begin VB.Menu HardMenuItem 
         Caption         =   "&Difficile"
         Shortcut        =   ^{F3}
      End
   End
   Begin VB.Menu Scores 
      Caption         =   "&Scores"
      Begin VB.Menu Consulter 
         Caption         =   "&Consulter"
         Shortcut        =   ^D
      End
      Begin VB.Menu Zro 
         Caption         =   "&Remise  zro"
         Shortcut        =   ^R
      End
   End
   Begin VB.Menu AideMenu 
      Caption         =   "&Aide"
      Begin VB.Menu AProposMenuItem 
         Caption         =   "&A propos du dmineur"
         Shortcut        =   ^A
      End
   End
End
Attribute VB_Name = "DmineurForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-----------------------------------------------------------------------
'- Le jeu du dmineur                                          ---------
'- Dominique LIARD - liard@infini-fr.com                       ---------
'- Exemple disponible  partir de http://www.infini-fr.com     ---------
'-----------------------------------------------------------------------
Option Explicit   ' Permet d'interdire l'utilisation de variable non prdfinies

Public AreaWidth As Integer, AreaHeight As Integer
Public OldAreaWidth As Integer, OldAreaHeight As Integer
Public ButtonWidth As Integer, ButtonHeight As Integer

Dim Area(99, 99) As Integer ' Mon aire de Jeu (taille 100*100 au maximum)

Public BombRatio As Single, bombNumber As Integer, toTest As Integer
Public Score As Integer

Const Checked = 0     ' 00000000
Const Occuped = 1     ' 00000001
Const Marked = 2      ' 00000010
Const Unknown = 128   ' 10000000

Dim fin

Private Sub AProposMenuItem_Click()
    frmAbout.Show vbModal
End Sub

' On souhaite consulter l'aide
Private Sub Consulter_Click()
    ScoresDialogBox.Show
End Sub

Private Sub EasyMenuItem_Click()
    BombRatio = 0.1
    EasyMenuItem.Checked = True
    NormalMenuItem.Checked = False
    HardMenuItem.Checked = False
End Sub

Private Sub FinirMenuItem_Click()
    TailleMenuItem.Enabled = True
    FinirMenuItem.Enabled = False
    NouvelleMenuItem.Enabled = True
    
    ' Affichage des scores
    If DmineurForm.Score <> 0 Then Identification.Show vbModal
End Sub

Private Sub Form_Terminate()
    ' Form_QueryUnload  -> Form_Unload -> Form_Terminate
    
    ' Que faire pour quitter correctement l'appli si une bote de dialogue  t ouverte ????
End Sub

Private Sub Form_QueryUnload(cancel As Integer, unloadmode As Integer)
    If MsgBox("Voulez-vous vraiment quitter ?", vbYesNo, Me.Caption) = vbNo Then
        cancel = True
    End If
End Sub


Private Sub HardMenuItem_Click()
    BombRatio = 0.3
    EasyMenuItem.Checked = False
    NormalMenuItem.Checked = False
    HardMenuItem.Checked = True
End Sub

Private Sub NormalMenuItem_Click()
    BombRatio = 0.2
    EasyMenuItem.Checked = False
    NormalMenuItem.Checked = True
    HardMenuItem.Checked = False
End Sub

' Que doit-on faire quand on click sur Quitter, dans le Menu ????
Private Sub QuitterMenuItem_Click()
    Unload DmineurForm  ' Dchargement de la feuille
End Sub

Private Sub NouvelleMenuItem_Click()
    TailleMenuItem.Enabled = False
    NouvelleMenuItem.Enabled = False
    FinirMenuItem.Enabled = True
    
    ' Remise  zro de l'aire de jeu
    Call InitArea
End Sub

' Initialise l'aire de jeu
Sub InitArea()
    ' Initialisation de l'aire de jeu
    Dim i As Integer, j As Integer, ratio As Single
    bombNumber = 0
    Score = 0
        
    For j = 0 To AreaHeight - 1
        For i = 0 To AreaWidth - 1
            ratio = Rnd
            If (ratio <= BombRatio) Then
                Area(i, j) = Occuped ' Il y a une bombe
                bombNumber = bombNumber + 1
            Else
                Area(i, j) = Unknown  ' Sans Bombe
            End If
        Next
    Next
    
    toTest = AreaWidth * AreaHeight - bombNumber
    Me.Refresh  ' Et hop, un petit affichage
    
    statusBar_Update
End Sub


' Demande de changement de taille de l'aire de jeu
Private Sub TailleMenuItem_Click()
    TailleDialogBox.Show vbModal
End Sub

' Remise  zro de la table de scores
Private Sub Zro_Click()
    ScoresDialogBox.ResetButton_Click
End Sub

' Au chargement de l'application
Private Sub Form_Load()
    AreaWidth = 20
    AreaHeight = 10
    
    OldAreaWidth = 0
    OldAreaHeight = 0
    
    ButtonWidth = 300
    ButtonHeight = 300
    
    BombRatio = 0.25
    bombNumber = 0
    
    Randomize ' Initialisation du gnrateur pseudo-alatoire
    Call ChangeSize
        
    NouvelleMenuItem_Click ' Une partie est systmatiquement dmare
    
    ' Chargement des images correspondantes aux diffrents digits + une marque et une bombe
    Dim i, imageName
    For i = 0 To 8
        imageName = "img_" & i
        Me.Controls.Add "VB.PictureBox", imageName
        Me.Controls(imageName).Picture = LoadPicture("Images\" & imageName & ".bmp")
    Next
    Me.Controls.Add "VB.PictureBox", "img_bomb"
    Me.Controls("img_bomb").Picture = LoadPicture("Images\img_bomb.bmp")
End Sub

' Nettoie une zone de vide
Private Sub Clean(X As Single, Y As Single)
    If X - 1 >= 0 Then
        Form_MouseUp 1, 0, (X - 1) * ButtonWidth, Y * ButtonHeight
        If Y - 1 >= 0 Then
            Form_MouseUp 1, 0, (X - 1) * ButtonWidth, (Y - 1) * ButtonHeight
        End If
        If Y + 1 < AreaHeight Then
            Form_MouseUp 1, 0, (X - 1) * ButtonWidth, (Y + 1) * ButtonHeight
        End If
    End If
    
    If X + 1 < AreaWidth Then
        Form_MouseUp 1, 0, (X + 1) * ButtonWidth, Y * ButtonHeight
        If Y - 1 >= 0 Then
            Form_MouseUp 1, 0, (X + 1) * ButtonWidth, (Y - 1) * ButtonHeight
        End If
        If Y + 1 < AreaHeight Then
            Form_MouseUp 1, 0, (X + 1) * ButtonWidth, (Y + 1) * ButtonHeight
        End If
    End If
    
    If Y + 1 < AreaHeight Then
        Form_MouseUp 1, 0, X * ButtonWidth, (Y + 1) * ButtonHeight
    End If
    
    If Y - 1 >= 0 Then
        Form_MouseUp 1, 0, X * ButtonWidth, (Y - 1) * ButtonHeight
    End If
End Sub

' Compte le nombre de bombes aux alentours.
Private Function CountBomb(X As Integer, Y As Integer) As Integer
    Dim number As Integer
    number = 0
    
    If (X - 1) >= 0 Then  ' Bande de gauche
        If (Y - 1) >= 0 Then
            If IsABomb(X - 1, Y - 1) Then
                number = number + 1
            End If
        End If
        If IsABomb(X - 1, Y) Then
            number = number + 1
        End If
        If (Y + 1) < AreaHeight Then
            If IsABomb(X - 1, Y + 1) Then
                number = number + 1
            End If
        End If
    End If
    
    If (X + 1) < AreaWidth Then  ' Bande de Droite
        If (Y - 1) >= 0 Then
            If IsABomb(X + 1, Y - 1) Then
                number = number + 1
            End If
        End If
        If IsABomb(X + 1, Y) Then
            number = number + 1
        End If
        If (Y + 1) < AreaHeight Then
            If IsABomb(X + 1, Y + 1) Then
                number = number + 1
            End If
        End If
    End If
    
    'Test des deux du milieu
    If (Y - 1) >= 0 Then
        If IsABomb(X, Y - 1) Then
            number = number + 1
        End If
    End If
    If (Y + 1) < AreaHeight Then
        If IsABomb(X, Y + 1) Then
            number = number + 1
        End If
    End If
    
    CountBomb = number
    Exit Function
End Function

' Test si la cellule possde une bombe
Function IsABomb(X As Integer, Y As Integer) As Boolean
    IsABomb = Area(X, Y) Mod 2 = 1
    Exit Function
End Function

' Pour savoir si on clique sur les boutons de l'aire de jeu.
Private Sub Form_MouseUp(button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Est-on en cours de partie ?
    If NouvelleMenuItem.Enabled <> False Then
        Exit Sub
    End If
    
    ' Calcul de la position du click souris dans l'aire de jeu
    X = X \ ButtonWidth
    Y = Y \ ButtonHeight
    
    If X < 0 Or X > (AreaWidth - 1) Or Y < 0 Or Y > (AreaHeight - 1) Then
        Exit Sub
    End If
    
    ' A t-on dj trait cette zone
    If Area(X, Y) = Checked Then
        Beep
        Exit Sub
    End If
    
    ' Traitement du click
    Select Case button
        Case 1   ' Bouton Gauche
            If IsABomb(CInt(X), CInt(Y)) Then
                Me.PaintPicture Me.Controls("img_bomb"), _
                                X * ButtonWidth, _
                                Y * ButtonHeight
                                
                MsgBox "Perdu"
                FinirMenuItem_Click
                Exit Sub
            Else
                Area(X, Y) = Checked
                                
                toTest = toTest - 1
                
                If CountBomb(CInt(X), CInt(Y)) = 0 Then
                    Call Clean(X, Y)
                End If
                
                Score = Score + 1
                statusBar_Update
            End If
        Case 2   ' Bouton Droit
            If Not IsABomb(CInt(X), CInt(Y)) Then  ' Perdu.
                Me.PaintPicture Me.Controls("img_" & CountBomb(CInt(X), CInt(Y))), _
                                X * ButtonWidth, _
                                Y * ButtonHeight
                MsgBox "Perdu"
                FinirMenuItem_Click
                Exit Sub
            End If
            
            Area(X, Y) = Occuped + Marked
            
            bombNumber = bombNumber - 1
            statusBar_Update
            
            If toTest = 0 Then
                Form_Paint
                MsgBox "You are the best"
                FinirMenuItem_Click
            End If
        Case 4   ' Bouton du milieu ???
    End Select
    Form_Paint
End Sub

' Dessine le contenu de la feuille
Private Sub Form_Paint()
    Dim i As Integer, j As Integer
    
    For j = 0 To AreaHeight - 1
        For i = 0 To AreaWidth - 1
            Select Case Area(i, j)
                Case Unknown, Occuped
                    Me.ForeColor = RGB(255, 255, 255)
                    Me.Line (i * ButtonWidth, j * ButtonHeight)-((i + 1) * ButtonWidth - 10, j * ButtonHeight)
                    Me.ForeColor = RGB(0, 0, 0)
                    Me.Line -((i + 1) * ButtonWidth - 10, (j + 1) * ButtonHeight - 10)
                    Me.Line -(i * ButtonWidth, (j + 1) * ButtonHeight - 10)
                    Me.Line -(i * ButtonWidth, (j + 1) * ButtonHeight - 30)
                    Me.ForeColor = RGB(255, 255, 255)
                    Me.Line -(i * ButtonWidth, j * ButtonHeight - 10)
                Case Occuped + Marked
                    Me.PaintPicture Me.Controls("img_bomb"), _
                                    i * ButtonWidth, _
                                    j * ButtonHeight
                Case Checked
                    Dim value, bName
                    value = CountBomb(i, j)
                    bName = "img_" & value
                    
                    Me.PaintPicture Me.Controls(bName), _
                                    i * ButtonWidth, _
                                    j * ButtonHeight
            End Select
        Next
    Next
End Sub

' Met  jour ma barre de status
Sub statusBar_Update()
    statusBar.Caption = "Votre score est de : " & Score & " - Il reste " & bombNumber & " bombes."
End Sub

' Permet de faire changer la taille de l'aire de jeu.
Public Sub ChangeSize()
    ' On retaille la fentre
    Me.Width = ButtonWidth * AreaWidth + 120
    Me.Height = ButtonHeight * AreaHeight + 700 + 200
    statusBar.Top = ButtonHeight * AreaHeight + 10
    statusBar.Width = Me.Width - 100
        
    ' Sauvegarde de la taille de l'aire de jeu
    OldAreaWidth = AreaWidth
    OldAreaHeight = AreaHeight
    
    ' Remise  zro de l'aire de jeu
    Call InitArea
End Sub
